Index: /trunk/kDbg/kDbgModWinDbgHelp.cpp
===================================================================
--- /trunk/kDbg/kDbgModWinDbgHelp.cpp	(revision 3530)
+++ /trunk/kDbg/kDbgModWinDbgHelp.cpp	(revision 3531)
@@ -87,5 +87,5 @@
  * @param   rc          The Windows error.
  */
-static int kDbgModPeConvWinError(DWORD rc)
+static int kdbgModDHConvWinError(DWORD rc)
 {
     switch (rc)
@@ -107,5 +107,5 @@
  * @param   puRVA       Where to store the RVA on success.
  */
-static int kDbgModPeSegOffToRVA(PKDBGMODDBGHELP pModDH, int32_t iSegment, KDBGADDR off, uint32_t *puRVA)
+static int kdbgModDHSegOffToRVA(PKDBGMODDBGHELP pModDH, int32_t iSegment, KDBGADDR off, uint32_t *puRVA)
 {
     if (iSegment >= 0)
@@ -141,5 +141,5 @@
  * @param   poff        Where to store the segment offset.
  */
-static int kDbgModPeRVAToSegOff(PKDBGMODDBGHELP pModDH, uint32_t uRVA, int32_t *piSegment, KDBGADDR *poff)
+static int kdbgModDHRVAToSegOff(PKDBGMODDBGHELP pModDH, uint32_t uRVA, int32_t *piSegment, KDBGADDR *poff)
 {
     kDbgAssertMsgReturn(uRVA < pModDH->cbImage, ("uRVA=%x, cbImage=%x\n", uRVA, pModDH->cbImage),
@@ -171,5 +171,5 @@
      */
     uint32_t uRVA;
-    int rc = kDbgModPeSegOffToRVA(pModDH, iSegment, off, &uRVA);
+    int rc = kdbgModDHSegOffToRVA(pModDH, iSegment, off, &uRVA);
     if (!rc)
     {
@@ -180,5 +180,5 @@
         {
             pLine->RVA = (KDBGADDR)(Line.Address - pModDH->ImageBase);
-            rc = kDbgModPeRVAToSegOff(pModDH, (uint32_t)pLine->RVA, &pLine->iSegment, &pLine->offSegment);
+            rc = kdbgModDHRVAToSegOff(pModDH, (uint32_t)pLine->RVA, &pLine->iSegment, &pLine->offSegment);
             pLine->iLine = Line.LineNumber;
             size_t cchFile = strlen(Line.FileName);
@@ -192,5 +192,5 @@
         {
             DWORD Err = GetLastError();
-            rc = kDbgModPeConvWinError(Err);
+            rc = kdbgModDHConvWinError(Err);
         }
     }
@@ -210,5 +210,5 @@
      */
     uint32_t uRVA;
-    int rc = kDbgModPeSegOffToRVA(pModDH, iSegment, off, &uRVA);
+    int rc = kdbgModDHSegOffToRVA(pModDH, iSegment, off, &uRVA);
     if (!rc)
     {
@@ -242,5 +242,5 @@
             {
                 pSym->RVA        = (KDBGADDR)(Buf.Sym.Address - pModDH->ImageBase);
-                rc = kDbgModPeRVAToSegOff(pModDH, (uint32_t)pSym->RVA, &pSym->iSegment, &pSym->offSegment);
+                rc = kdbgModDHRVAToSegOff(pModDH, (uint32_t)pSym->RVA, &pSym->iSegment, &pSym->offSegment);
             }
             pSym->cchName = (uint16_t)Buf.Sym.NameLen;
@@ -253,5 +253,5 @@
         {
             DWORD Err = GetLastError();
-            rc = kDbgModPeConvWinError(Err);
+            rc = kdbgModDHConvWinError(Err);
         }
     }
@@ -271,5 +271,5 @@
 
     DWORD Err = GetLastError();
-    int rc = kDbgModPeConvWinError(Err);
+    int rc = kdbgModDHConvWinError(Err);
     kDbgAssertMsgFailed(("SymInitialize failed: Err=%d rc=%Rrc\n", Err, rc));
     return rc;
@@ -326,8 +326,8 @@
         }
         else
-            rc = kDbgModPeConvWinError(GetLastError());
+            rc = kdbgModDHConvWinError(GetLastError());
     }
     else
-        rc = kDbgModPeConvWinError(GetLastError());
+        rc = kdbgModDHConvWinError(GetLastError());
     return rc;
 }
@@ -478,5 +478,5 @@
     {
         DWORD Err = GetLastError();
-        int rc = kDbgModPeConvWinError(Err);
+        int rc = kdbgModDHConvWinError(Err);
         kDbgAssertMsgFailedReturn(("Failed to load '%s', Err=%d rc=%Rrc\n", szPath, Err, rc), rc);
     }
@@ -521,5 +521,5 @@
                 {
                     DWORD Err = GetLastError();
-                    rc = kDbgModPeConvWinError(Err);
+                    rc = kdbgModDHConvWinError(Err);
                     kDbgAssertMsgFailed(("Failed to resolve %s in dbghelp, Err=%d rc=%Rrc\n",
                                      s_aFunctions[i].pszName, Err, rc));
@@ -546,5 +546,5 @@
     {
         DWORD Err = GetLastError();
-        rc = kDbgModPeConvWinError(Err);
+        rc = kdbgModDHConvWinError(Err);
         kDbgAssertMsgFailed(("Failed to resolve ImagehlpApiVersionEx in dbghelp, Err=%d rc=%Rrc\n", Err, rc));
     }
@@ -668,5 +668,5 @@
 
             DWORD Err = GetLastError();
-            rc = kDbgModPeConvWinError(Err);
+            rc = kdbgModDHConvWinError(Err);
             kDbgAssertMsgFailed(("SymLoadModule64 failed: Err=%d rc=%Rrc\n", Err, rc));
             g_pfnSymCleanup(hSymInst);
@@ -675,5 +675,5 @@
         {
             DWORD Err = GetLastError();
-            rc = kDbgModPeConvWinError(Err);
+            rc = kdbgModDHConvWinError(Err);
             kDbgAssertMsgFailed(("SymInitialize failed: Err=%d rc=%Rrc\n", Err, rc));
         }