Index: trunk/src/shell32/makefile
===================================================================
--- trunk/src/shell32/makefile	(revision 3551)
+++ trunk/src/shell32/makefile	(revision 3554)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.24 2000-05-18 14:16:03 sandervl Exp $
+# $Id: makefile,v 1.25 2000-05-18 18:06:59 sandervl Exp $
 
 #
@@ -42,4 +42,5 @@
 $(OBJDIR)\shellpath.obj \
 $(OBJDIR)\shellole.obj \
+$(OBJDIR)\shellstub.obj \
 $(OBJDIR)\shellord.obj \
 $(OBJDIR)\shv_bg_cmenu.obj \
Index: trunk/src/shell32/shell32.def
===================================================================
--- trunk/src/shell32/shell32.def	(revision 3551)
+++ trunk/src/shell32/shell32.def	(revision 3554)
@@ -1,3 +1,3 @@
-; $Id: shell32.def,v 1.24 2000-05-18 14:16:03 sandervl Exp $
+; $Id: shell32.def,v 1.25 2000-05-18 18:06:59 sandervl Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -34,5 +34,5 @@
     ILCombine                         = _ILCombine@8                          @25
     ILLoadFromStream                  = _ILLoadFromStream@8                   @26
-;   ILSaveToStream                    = _ILSaveToStream@8                     @27
+    ILSaveToStream                    = _ILSaveToStream@8                     @27
     SHILCreateFromPath                = _SHILCreateFromPathAW@12              @28
     PathIsRoot                        = _PathIsRootAW@4                       @29
@@ -72,6 +72,6 @@
     GetFileNameFromBrowse             = _GetFileNameFromBrowse@28             @63
     DriveType                         = _DriveType@4                          @64
-;   InvalidateDriveType               = _InvalidateDriveType@?                @65
-;   IsNetDrive                        = _IsNetDrive@?                         @66
+    InvalidateDriveType               = _InvalidateDriveType@4                @65
+    IsNetDrive                        = _IsNetDrive@4                         @66
     Shell_MergeMenus                  = _Shell_MergeMenus@24                  @67
     SHGetSettings                     = _SHGetSettings@12                     @68
@@ -83,5 +83,5 @@
 ;   Shell_GetCachedImageIndexA        = _Shell_GetCachedImageIndexA@12
     SHShellFolderView_Message         = _SHShellFolderView_Message@12         @73
-;   SHCreateStdEnumFmtEtc             = _SHCreateStdEnumFmtEtc@?              @74
+    SHCreateStdEnumFmtEtc             = _SHCreateStdEnumFmtEtc@12             @74
     PathYetAnotherMakeUniqueName      = _PathYetAnotherMakeUniqueNameAW@16    @75
 ;   DragQueryInfo                     = _DragQueryInfo@?                      @76
@@ -92,5 +92,5 @@
     DragQueryFile                     = _DragQueryFileA@16                    @81
     DragQueryFileA                    = _DragQueryFileA@16                    @82
-;   CIDLData_CreateFromIDArray        = _CIDLData_CreateFromIDArray@?         @83
+    CIDLData_CreateFromIDArray        = _CIDLData_CreateFromIDArray@16        @83
 ;   SHIsBadInterfacePtr               = _SHIsBadInterfacePtr@?                @84
     OpenRegStream                     = _OpenRegStream@16                     @85
@@ -99,6 +99,6 @@
     SHDoDragDrop                      = _SHDoDragDrop@24                      @88
     SHCloneSpecialIDList              = _SHCloneSpecialIDList@12              @89
-;   SHFindFiles                       = _SHFindFiles@?                        @90
-;   SHFindComputer                    = _SHFindComputer@?                     @91
+    SHFindFiles                       = _SHFindFiles@8                        @90
+    SHFindComputer                    = _SHFindComputer@8                     @91
     PathGetShortPath                  = _PathGetShortPathAW@4                 @92
 ;   Win32CreateDirectory              = _Win32CreateDirectory@?               @93
@@ -138,15 +138,15 @@
     SHWinHelp                         = _SHWinHelp@16                         @127
     DllGetClassObject                 = _SHELL32_DllGetClassObject@12         @128
-;   DAD_AutoScroll                    = _DAD_AutoScroll@?                     @129
-;   DAD_DragEnter                     = _DAD_DragEnter@?                      @130
-;   DAD_DragEnterEx                   = _DAD_DragEnterEx@?                    @131
-;   DAD_DragLeave                     = _DAD_DragLeave@?                      @132
+    DAD_AutoScroll                    = _DAD_AutoScroll@12                    @129
+    DAD_DragEnter                     = _DAD_DragEnter@4                      @130
+    DAD_DragEnterEx                   = _DAD_DragEnterEx@12                   @131
+    DAD_DragLeave                     = _DAD_DragLeave@0                      @132
     DragQueryFileW                    = _DragQueryFileW@16                    @133
-;   DAD_DragMove                      = _DAD_DragMove@?                       @134
+    DAD_DragMove                      = _DAD_DragMove@8                       @134
     DragQueryPoint                    = _DragQueryPoint@8                     @135
     DAD_SetDragImage                  = _DAD_SetDragImage@8                   @136
     DAD_ShowDragImage                 = _DAD_ShowDragImage@4                  @137
     DuplicateIcon                     = _DuplicateIcon@4                      @138
-;   Desktop_UpdateBriefcaseOnEvent    = _Desktop_UpdateBriefcaseOnEvent@?     @139
+    Desktop_UpdateBriefcaseOnEvent    = _Desktop_UpdateBriefcaseOnEvent@4     @139
     FileMenu_DeleteItemByIndex        = _FileMenu_DeleteItemByIndex@8         @140
     FileMenu_DeleteItemByFirstID      = _FileMenu_DeleteItemByFirstID@8       @141
@@ -173,5 +173,5 @@
     SHSimpleIDListFromPath            = _SHSimpleIDListFromPathAW@4           @162
     StrToOleStr                       = _StrToOleStr@8                        @163
-;   Win32DeleteFile                   = _Win32DeleteFile@?                    @164
+    Win32DeleteFile                   = _Win32DeleteFile@4                    @164
     SHCreateDirectory                 = _SHCreateDirectory@8                  @165
 ;   CallCPLEntry16                    = _CallCPLEntry16@?                     @166
@@ -194,5 +194,5 @@
     ShellMessageBoxA                  = _ShellMessageBoxA                     @183 ;cdecl
     ArrangeWindows                    = _ArrangeWindows@20                    @184
-;   SHHandleDiskFull                  = _SHHandleDiskFull@?                   @185
+    SHHandleDiskFull                  = _SHHandleDiskFull@8                   @185
     ExtractAssociatedIconExW          = _ExtractAssociatedIconExW@12          @186
     ExtractAssociatedIconW            = _ExtractAssociatedIconW@12            @187
@@ -206,5 +206,5 @@
     SHFree                            = _SHFree@4                             @195
     SHAlloc                           = _SHAlloc@4                            @196
-;   SHGlobalDefect                    = _SHGlobalDefect@?                     @197
+    SHGlobalDefect                    = _SHGlobalDefect@4                     @197
     SHAbortInvokeCommand              = _SHAbortInvokeCommand@0               @198
 ;   SHGetFileIcon                     = _SHGetFileIcon@?                      @199
@@ -372,4 +372,6 @@
 ;   FOOBAR1217                        = _FOOBAR1217@?                         @1217
 
+    DllGetVersion                     = _SHELL32_DllGetVersion@4              @1220
+
     VERSION_OsIsUnicode                   @1000
     _StrRetToStrNA@16                     @1004
Index: trunk/src/shell32/shellstub.cpp
===================================================================
--- trunk/src/shell32/shellstub.cpp	(revision 3554)
+++ trunk/src/shell32/shellstub.cpp	(revision 3554)
@@ -0,0 +1,130 @@
+/* $Id: shellstub.cpp,v 1.1 2000-05-18 18:06:59 sandervl Exp $ */
+
+/*
+ * Win32 SHELL32 for OS/2
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ */
+
+
+/*****************************************************************************
+ * Includes                                                                  *
+ *****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2sel.h>
+
+#include <string.h>
+#include <ctype.h>
+#include <wctype.h>
+#define HAVE_WCTYPE_H
+#include <odin.h>
+
+#define ICOM_CINTERFACE 1
+#define CINTERFACE 1
+
+#include "debugtools.h"
+#include "winnls.h"
+#include "winversion.h"
+#include "winreg.h"
+#include "crtdll.h"
+
+#include "shlobj.h"
+#include "shell32_main.h"
+
+#include <heapstring.h>
+#include <misc.h>
+
+
+ODINDEBUGCHANNEL(SHELL32-SHELLSTUB)
+
+ODINFUNCTION3(DWORD, SHCreateStdEnumFmtEtc, DWORD, x1, DWORD, x2, DWORD, x3)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION4(DWORD, CIDLData_CreateFromIDArray, DWORD, x1, DWORD, x2, DWORD, x3, DWORD, x4)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION2(DWORD, SHFindFiles, DWORD, x1, DWORD, x2)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION2(DWORD, SHFindComputer, DWORD, x1, DWORD, x2)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION3(DWORD, DAD_AutoScroll, DWORD, x1, DWORD, x2, DWORD, x3)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION1(DWORD, DAD_DragEnter, DWORD, x1)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION3(DWORD, DAD_DragEnterEx, DWORD, x1, DWORD, x2, DWORD, x3)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION0(DWORD, DAD_DragLeave)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION2(DWORD, DAD_DragMove, DWORD, x1, DWORD, x2)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION1(DWORD, Desktop_UpdateBriefcaseOnEvent, DWORD, x1)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION2(DWORD, ILSaveToStream, DWORD, x1, DWORD, x2)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION1(DWORD, InvalidateDriveType, DWORD, x1)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION1(DWORD, IsNetDrive, DWORD, x1)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION1(DWORD, SHGlobalDefect, DWORD, x1)
+{
+  dprintf(("STUB!"));
+  return 0;
+}
+
+ODINFUNCTION2(DWORD, SHHandleDiskFull, DWORD, x1, DWORD, x2)
+{
+  dprintf(("STUB!"));
+  return 0;
+}