Index: trunk/src/shell32/misc.cpp
===================================================================
--- trunk/src/shell32/misc.cpp	(revision 3557)
+++ trunk/src/shell32/misc.cpp	(revision 3561)
@@ -1,3 +1,3 @@
-/* $Id: misc.cpp,v 1.6 1999-10-19 10:23:26 phaller Exp $ */
+/* $Id: misc.cpp,v 1.7 2000-05-19 12:09:24 sandervl Exp $ */
 
 /*
@@ -286,49 +286,4 @@
 }
 
-
-/*****************************************************************************
- * Name      : StrCpyNW
- * Purpose   :
- * Parameters:
- * Variables :
- * Result    :
- * Remark    : SHELL32.310 - used by winfile.exe
- * Status    : UNTESTED UNKNOWN STUB
- *
- * Author    : Christoph Bratschi [Fri, 1999/08/6 19:00]
- *****************************************************************************/
-
-ODINFUNCTION3(LPWSTR, StrCpyNW,
-              LPWSTR, lpString1,
-              LPWSTR, lpString2,
-              int,    iMaxLength)
-{
-  dprintf(("SHELL32: undoc StrCpyNW\n"));
-
-  return lstrcpynW(lpString1,lpString2,iMaxLength);
-}
-
-/*****************************************************************************
- * Name      : StrNCpyW
- * Purpose   :
- * Parameters:
- * Variables :
- * Result    :
- * Remark    : SHELL32.316 - used by winfile.exe
- * Status    : UNTESTED UNKNOWN STUB
- *
- * Author    : Christoph Bratschi [Fri, 1999/08/6 19:00]
- *****************************************************************************/
-
-ODINFUNCTION2(LPWSTR, StrNCpyW,
-              LPWSTR, lpString1,
-              LPWSTR, lpString2)
-{
-  dprintf(("SHELL32: undoc StrNCpyW\n"));
-
-  return lstrcpyW(lpString1,lpString2);
-}
-
-
 /*****************************************************************************
  * Name      : InternalExtractIconListA
@@ -402,27 +357,4 @@
   return 0;
 }
-
-/*************************************************************************
- *				FindEnvironmentString	[SHELL.38]
- *
- * Returns a pointer into the DOS environment... Ugh.
- */
-LPSTR SHELL_FindStringA(LPSTR lpEnv, LPCSTR entry)
-{ UINT16 l;
-
-  //TRACE_(shell)("\n");
-
-  l = strlen(entry);
-  for( ; *lpEnv ; lpEnv+=strlen(lpEnv)+1 )
-  { if( lstrncmpiA(lpEnv, entry, l) )
-      continue;
-	if( !*(lpEnv+l) )
-	    return (lpEnv + l); 		/* empty entry */
-	else if ( *(lpEnv+l)== '=' )
-	    return (lpEnv + l + 1);
-    }
-    return NULL;
-}
-
 
 /*****************************************************************************
Index: trunk/src/shell32/shell32.def
===================================================================
--- trunk/src/shell32/shell32.def	(revision 3557)
+++ trunk/src/shell32/shell32.def	(revision 3561)
@@ -1,3 +1,3 @@
-; $Id: shell32.def,v 1.25 2000-05-18 18:06:59 sandervl Exp $
+; $Id: shell32.def,v 1.26 2000-05-19 12:09:25 sandervl Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -318,12 +318,12 @@
     StrCmpNIW                         = _StrCmpNIW@12                         @307
 ;   StrCmpNW                          = _StrCmpNW@?                           @308
-;   StrCpyNA                          = _StrCpyNA@?                           @309
-    StrCpyNW                          = _StrCpyNW@12                          @310
+    StrCpyNA                          = _lstrcpynA@12                         @309
+    StrCpyNW                          = _lstrcpynW@12                         @310
 ;   StrNCmpA                          = _StrNCmpA@?                           @311
 ;   StrNCmpIA                         = _StrNCmpIA@?                          @312
 ;   StrNCmpIW                         = _StrNCmpIW@?                          @313
 ;   StrNCmpW                          = _StrNCmpW@?                           @314
-;   StrCpyA                           = _StrCpyA@?                            @315
-    StrNCpyW                          = _StrNCpyW@8                           @316
+    StrNCpyA                          = _lstrcpynA@12                         @315
+    StrNCpyW                          = _lstrcpynW@12                         @316
     StrRChrA                          = _StrRChrA@12                          @317
 ;   StrRChrIA                         = _StrRChrIA@?                          @318
@@ -374,5 +374,4 @@
     DllGetVersion                     = _SHELL32_DllGetVersion@4              @1220
 
-    VERSION_OsIsUnicode                   @1000
     _StrRetToStrNA@16                     @1004
     _StrRetToStrNW@16                     @1005