Index: trunk/kBuild/tools/CLANGCCMACHO.kmk
===================================================================
--- trunk/kBuild/tools/CLANGCCMACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/CLANGCCMACHO.kmk	(revision 3567)
@@ -77,11 +77,4 @@
 TOOL_CLANGCCMACHO_STRIP_SYSMOD  ?= $(TOOL_CLANGCCMACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_CLANGCCMACHO_CC     += -fmessage-length=0
-TOOL_CLANGCCMACHO_CXX    += -fmessage-length=0
-TOOL_CLANGCCMACHO_OBJC   += -fmessage-length=0
-TOOL_CLANGCCMACHO_OBJCXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_CLANGCCMACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/CLANGXXMACHO.kmk
===================================================================
--- trunk/kBuild/tools/CLANGXXMACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/CLANGXXMACHO.kmk	(revision 3567)
@@ -77,11 +77,4 @@
 TOOL_CLANGXXMACHO_STRIP_SYSMOD  ?= $(TOOL_CLANGXXMACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_CLANGXXMACHO_CC     += -fmessage-length=0
-TOOL_CLANGXXMACHO_CXX    += -fmessage-length=0
-TOOL_CLANGXXMACHO_OBJC   += -fmessage-length=0
-TOOL_CLANGXXMACHO_OBJCXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_CLANGXXMACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GCC3.kmk
===================================================================
--- trunk/kBuild/tools/GCC3.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC3.kmk	(revision 3567)
@@ -79,9 +79,4 @@
 endif
 TOOL_GCC3_OBJCOPY ?= $(TOOL_GCC3_PREFIX2)objcopy$(TOOL_GCC3_SUFFIX2)
-
-ifdef SLKRUNS
- TOOL_GCC3_CC  += -fmessage-length=0
- TOOL_GCC3_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GCC32.kmk
===================================================================
--- trunk/kBuild/tools/GCC32.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC32.kmk	(revision 3567)
@@ -79,9 +79,4 @@
 endif
 TOOL_GCC32_OBJCOPY ?= $(TOOL_GCC32_PREFIX2)objcopy$(TOOL_GCC32_SUFFIX2)
-
-ifdef SLKRUNS
- TOOL_GCC32_CC  += -fmessage-length=0
- TOOL_GCC32_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GCC3OMF.kmk
===================================================================
--- trunk/kBuild/tools/GCC3OMF.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC3OMF.kmk	(revision 3567)
@@ -59,9 +59,4 @@
 TOOL_GCC3OMF_RC = $(TOOL_GCC3OMF_PREFIX3)rc$(TOOL_GCC3OMF_SUFFIX3)
 
-ifdef SLKRUNS
-TOOL_GCC3OMF_CC  += -fmessage-length=0
-TOOL_GCC3OMF_CXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_GCC3OMF_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GCC3PLAIN.kmk
===================================================================
--- trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 3567)
@@ -67,8 +67,4 @@
  TOOL_GCC3PLAIN_LD_SONAME ?= $(TOOL_GCC3PLAIN_LD_SONAME.$(KBUILD_TARGET))
 endif
-ifdef SLKRUNS
- TOOL_GCC3PLAIN_CC  += -fmessage-length=0
- TOOL_GCC3PLAIN_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GCC42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/GCC42MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC42MACHO.kmk	(revision 3567)
@@ -54,11 +54,4 @@
 #TOOL_GCC42MACHO_LD_SONAME = -Wl,-dylib_install_name $(firstword $($(1)_SONAME.$(KBUILD_TARGET).$(KBUILD_TYPE)) $($(1)_SONAME.$(KBUILD_TARGET)) $($(1)_SONAME.$(KBUILD_TYPE)) $($(1)_SONAME) $(notdir $(2)))
 
-ifdef SLKRUNS
-TOOL_GCC42MACHO_CC        += -fmessage-length=0
-TOOL_GCC42MACHO_CXX       += -fmessage-length=0
-TOOL_GCC42MACHO_OBJC      += -fmessage-length=0
-TOOL_GCC42MACHO_OBJCXX    += -fmessage-length=0
-endif
-
 TOOL_GCC42MACHO_AR        ?= $(TOOL_GCC4MACHO_PREFIX2)ar$(TOOL_GCC4MACHO_SUFFIX2)
 TOOL_GCC42MACHO_DSYMUTIL  ?= $(TOOL_GCC4MACHO_PREFIX2)dsymutil$(TOOL_GCC4MACHO_SUFFIX2)
Index: trunk/kBuild/tools/GCC4MACHO.kmk
===================================================================
--- trunk/kBuild/tools/GCC4MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC4MACHO.kmk	(revision 3567)
@@ -61,11 +61,4 @@
 TOOL_GCC4MACHO_STRIP_SYSMOD  ?= $(TOOL_GCC4MACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_GCC4MACHO_CC        += -fmessage-length=0
-TOOL_GCC4MACHO_CXX       += -fmessage-length=0
-TOOL_GCC4MACHO_OBJC      += -fmessage-length=0
-TOOL_GCC4MACHO_OBJCXX    += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_GCC4MACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GCC64.kmk
===================================================================
--- trunk/kBuild/tools/GCC64.kmk	(revision 3566)
+++ trunk/kBuild/tools/GCC64.kmk	(revision 3567)
@@ -78,9 +78,4 @@
 endif
 TOOL_GCC64_OBJCOPY ?= $(TOOL_GCC64_PREFIX2)gobjcopy$(TOOL_GCC64_SUFFIX2)
-
-ifdef SLKRUNS
- TOOL_GCC64_CC  += -fmessage-length=0
- TOOL_GCC64_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GXX3.kmk
===================================================================
--- trunk/kBuild/tools/GXX3.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX3.kmk	(revision 3567)
@@ -81,10 +81,4 @@
 endif
 TOOL_GXX3_OBJCOPY ?= $(TOOL_GXX3_PREFIX)objcopy$(TOOL_GXX3_SUFFIX)
-
-ifdef SLKRUNS
- TOOL_GXX3_CC  += -fmessage-length=0
- TOOL_GXX3_CXX += -fmessage-length=0
- TOOL_GXX3_PCH += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GXX32.kmk
===================================================================
--- trunk/kBuild/tools/GXX32.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX32.kmk	(revision 3567)
@@ -79,9 +79,4 @@
 endif
 TOOL_GXX32_OBJCOPY ?= $(TOOL_GXX32_PREFIX2)objcopy$(TOOL_GXX32_SUFFIX)
-
-ifdef SLKRUNS
- TOOL_GXX32_CC  += -fmessage-length=0
- TOOL_GXX32_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GXX3OMF.kmk
===================================================================
--- trunk/kBuild/tools/GXX3OMF.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX3OMF.kmk	(revision 3567)
@@ -64,9 +64,4 @@
 TOOL_GXX3OMF_RC = $(TOOL_GXX3OMF_PREFIX3)rc$(TOOL_GXX3OMF_SUFFIX3)
 
-ifdef SLKRUNS
- TOOL_GXX3OMF_CC  += -fmessage-length=0
- TOOL_GXX3OMF_CXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_GXX3OMF_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GXX3PLAIN.kmk
===================================================================
--- trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 3567)
@@ -68,8 +68,4 @@
  TOOL_GXX3PLAIN_LD_SONAME ?= $(TOOL_GXX3PLAIN_LD_SONAME.$(KBUILD_TARGET))
 endif
-ifdef SLKRUNS
- TOOL_GXX3PLAIN_CC  += -fmessage-length=0
- TOOL_GXX3PLAIN_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/GXX42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/GXX42MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX42MACHO.kmk	(revision 3567)
@@ -62,11 +62,4 @@
 TOOL_GXX42MACHO_STRIP_SYSMOD     ?= $(TOOL_GXX42MACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_GXX42MACHO_CC     += -fmessage-length=0
-TOOL_GXX42MACHO_CXX    += -fmessage-length=0
-TOOL_GXX42MACHO_OBJC   += -fmessage-length=0
-TOOL_GXX42MACHO_OBJCXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_GXX42MACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GXX4MACHO.kmk
===================================================================
--- trunk/kBuild/tools/GXX4MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX4MACHO.kmk	(revision 3567)
@@ -62,11 +62,4 @@
 TOOL_GXX4MACHO_STRIP_SYSMOD  ?= $(TOOL_GXX4MACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_GXX4MACHO_CC     += -fmessage-length=0
-TOOL_GXX4MACHO_CXX    += -fmessage-length=0
-TOOL_GXX4MACHO_OBJC   += -fmessage-length=0
-TOOL_GXX4MACHO_OBJCXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_GXX4MACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/GXX64.kmk
===================================================================
--- trunk/kBuild/tools/GXX64.kmk	(revision 3566)
+++ trunk/kBuild/tools/GXX64.kmk	(revision 3567)
@@ -79,9 +79,4 @@
 endif
 TOOL_GXX64_OBJCOPY ?= $(TOOL_GXX64_PREFIX2)objcopy$(TOOL_GXX64_SUFFIX2)
-
-ifdef SLKRUNS
- TOOL_GXX64_CC  += -fmessage-length=0
- TOOL_GXX64_CXX += -fmessage-length=0
-endif
 
 # General Properties used by kBuild
Index: trunk/kBuild/tools/LLVMGCC42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/LLVMGCC42MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/LLVMGCC42MACHO.kmk	(revision 3567)
@@ -61,12 +61,4 @@
 TOOL_LLVMGCC42MACHO_STRIP_SYSMOD  ?= $(TOOL_LLVMGCC42MACHO_STRIP) -Sru
 
-
-ifdef SLKRUNS
-TOOL_LLVMGCC42MACHO_CC        += -fmessage-length=0
-TOOL_LLVMGCC42MACHO_CXX       += -fmessage-length=0
-TOOL_LLVMGCC42MACHO_OBJC      += -fmessage-length=0
-TOOL_LLVMGCC42MACHO_OBJCXX    += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_LLVMGCC42MACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/LLVMGXX42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/LLVMGXX42MACHO.kmk	(revision 3566)
+++ trunk/kBuild/tools/LLVMGXX42MACHO.kmk	(revision 3567)
@@ -62,11 +62,4 @@
 TOOL_LLVMGXX42MACHO_STRIP_SYSMOD  ?= $(TOOL_LLVMGXX42MACHO_STRIP) -Sru
 
-ifdef SLKRUNS
-TOOL_LLVMGXX42MACHO_CC     += -fmessage-length=0
-TOOL_LLVMGXX42MACHO_CXX    += -fmessage-length=0
-TOOL_LLVMGXX42MACHO_OBJC   += -fmessage-length=0
-TOOL_LLVMGXX42MACHO_OBJCXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_LLVMGXX42MACHO_COBJSUFF         ?= .o
Index: trunk/kBuild/tools/XGCCAMD64LINUX.kmk
===================================================================
--- trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 3566)
+++ trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 3567)
@@ -83,9 +83,4 @@
 TOOL_XGCCAMD64LINUX_LDFLAGS.sysmod ?= -r
 
-ifdef SLKRUNS
-TOOL_XGCCAMD64LINUX_CC  += -fmessage-length=0
-TOOL_XGCCAMD64LINUX_CXX += -fmessage-length=0
-endif
-
 # General Properties used by kBuild
 TOOL_XGCCAMD64LINUX_COBJSUFF         ?= .o